#ifndef _SAMPLEAPP_H_
#define _SAMPLEAPP_H_


#define SAMAPP_Lenaface40_SIZE (2769)
#define SAMAPP_Mandrill256_SIZE (14368)
#define SAMAPP_Roboto_BoldCondensed_12_SIZE (19348)

#define SAMAPP_ChineseFont_Metric_SIZE   (148)
#define SAMAPP_ChineseFont_BitmapData_SIZE   (20944)

#define ARDUINO_PLATFORM
#define SAMAPP_ENABLE_APIS_SET0

/* sample app structure definitions */
typedef struct SAMAPP_Bitmap_header
{
	uint8_t Format;
	int16_t Width;
	int16_t Height;
	int16_t Stride;
	int32_t Arrayoffset;
}SAMAPP_Bitmap_header_t;

extern SAMAPP_Bitmap_header_t  SAMAPP_Bitmap_RawData_Header[];

extern  PROGMEM prog_uchar SAMAPP_Bitmap_RawData[];
extern  PROGMEM prog_uchar Lenaface40[];
extern  PROGMEM prog_uchar Font16[];
extern  PROGMEM prog_uchar Mandrill256[];
extern  PROGMEM prog_uchar Roboto_BoldCondensed_12[];

/*The font data contains 22 chinese characters, which is generated by fnt_cvt utility from SimFang true type font file of Windows*/
extern  PROGMEM prog_uchar SAMApp_ChineseFont_MetricBlock[];
extern  PROGMEM prog_uchar  SAMApp_ChineseFont_FontBmpData[];

void SAMAPP_fadeout();
void SAMAPP_fadein();
int16_t SAMAPP_qsin(uint16_t a);
int16_t SAMAPP_qcos(uint16_t a);
/* Sample app APIs for graphics primitives */

void	SAMAPP_GPU_Points();
void	SAMAPP_GPU_Lines();
void	SAMAPP_GPU_Rectangles();
void	SAMAPP_GPU_Bitmap();
void	SAMAPP_GPU_Fonts();
void	SAMAPP_GPU_Text8x8();
void	SAMAPP_GPU_TextVGA();
void	SAMAPP_GPU_Bargraph();
void	SAMAPP_GPU_LineStrips();
void	SAMAPP_GPU_EdgeStrips();
void	SAMAPP_GPU_Scissor();
void	SAMAPP_GPU_FtdiString();
void	SAMAPP_GPU_StreetMap();
void	SAMAPP_GPU_AdditiveBlendText();
void	SAMAPP_GPU_MacroUsage();
void	SAMAPP_GPU_AdditiveBlendPoints();

/* Sample app APIs for widgets */
void SAMAPP_CoPro_Widget_Logo();
void SAMAPP_CoPro_Widget_Calibrate();
void SAMAPP_CoPro_AppendCmds();
void SAMAPP_CoPro_Inflate();
void SAMAPP_CoPro_Loadimage();
void SAMAPP_CoPro_Widget_Button();
void SAMAPP_CoPro_Widget_Clock();
void SAMAPP_CoPro_Widget_Guage();
void SAMAPP_CoPro_Widget_Gradient();
void SAMAPP_CoPro_Widget_Keys();
void SAMAPP_CoPro_Widget_Progressbar();
void SAMAPP_CoPro_Widget_Scroll();
void SAMAPP_CoPro_Widget_Slider();
void SAMAPP_CoPro_Widget_Dial();
void SAMAPP_CoPro_Widget_Toggle();
void SAMAPP_CoPro_Widget_Text();
void SAMAPP_CoPro_Widget_Number();
void SAMAPP_CoPro_Widget_Spinner();
void SAMAPP_CoPro_Screensaver();
void SAMAPP_CoPro_Snapshot();
void SAMAPP_CoPro_Sketch();
void SAMAPP_CoPro_Matrix();
void SAMAPP_CoPro_Setfont();
void SAMAPP_CoPro_Track();

void SAMAPP_PowerMode();
void SAMAPP_BootupConfig();

#endif

/* Nothing beyond this */










